=begin
#Pulp3 API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v3

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require "uri"

module Zest
  class PulpApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Artifact]
    def artifacts_create(data, opts = {})
      data, _status_code, _headers = artifacts_create_with_http_info(data, opts)
      return data
    end

    # 
    # 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Artifact, Fixnum, Hash)>] Artifact data, response status code and response headers
    def artifacts_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.artifacts_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.artifacts_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/artifacts/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Artifact')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#artifacts_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Remove Artifact only if it is not associated with any Content.
    # @param artifact_href URI of Artifact. e.g.: /pulp/api/v3/artifacts/1/
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def artifacts_delete(artifact_href, opts = {})
      artifacts_delete_with_http_info(artifact_href, opts)
      return nil
    end

    # 
    # Remove Artifact only if it is not associated with any Content.
    # @param artifact_href URI of Artifact. e.g.: /pulp/api/v3/artifacts/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def artifacts_delete_with_http_info(artifact_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.artifacts_delete ..."
      end
      # verify the required parameter 'artifact_href' is set
      if @api_client.config.client_side_validation && artifact_href.nil?
        fail ArgumentError, "Missing the required parameter 'artifact_href' when calling PulpApi.artifacts_delete"
      end
      # resource path
      local_var_path = "{artifact_href}".sub('{' + 'artifact_href' + '}', artifact_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#artifacts_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :md5 Filter results where md5 matches value
    # @option opts [String] :sha1 Filter results where sha1 matches value
    # @option opts [String] :sha224 Filter results where sha224 matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :sha384 Filter results where sha384 matches value
    # @option opts [String] :sha512 Filter results where sha512 matches value
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse200]
    def artifacts_list(opts = {})
      data, _status_code, _headers = artifacts_list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :md5 Filter results where md5 matches value
    # @option opts [String] :sha1 Filter results where sha1 matches value
    # @option opts [String] :sha224 Filter results where sha224 matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :sha384 Filter results where sha384 matches value
    # @option opts [String] :sha512 Filter results where sha512 matches value
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse200, Fixnum, Hash)>] InlineResponse200 data, response status code and response headers
    def artifacts_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.artifacts_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/artifacts/"

      # query parameters
      query_params = {}
      query_params[:'md5'] = opts[:'md5'] if !opts[:'md5'].nil?
      query_params[:'sha1'] = opts[:'sha1'] if !opts[:'sha1'].nil?
      query_params[:'sha224'] = opts[:'sha224'] if !opts[:'sha224'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'sha384'] = opts[:'sha384'] if !opts[:'sha384'].nil?
      query_params[:'sha512'] = opts[:'sha512'] if !opts[:'sha512'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse200')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#artifacts_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param artifact_href URI of Artifact. e.g.: /pulp/api/v3/artifacts/1/
    # @param [Hash] opts the optional parameters
    # @return [Artifact]
    def artifacts_read(artifact_href, opts = {})
      data, _status_code, _headers = artifacts_read_with_http_info(artifact_href, opts)
      return data
    end

    # 
    # 
    # @param artifact_href URI of Artifact. e.g.: /pulp/api/v3/artifacts/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Artifact, Fixnum, Hash)>] Artifact data, response status code and response headers
    def artifacts_read_with_http_info(artifact_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.artifacts_read ..."
      end
      # verify the required parameter 'artifact_href' is set
      if @api_client.config.client_side_validation && artifact_href.nil?
        fail ArgumentError, "Missing the required parameter 'artifact_href' when calling PulpApi.artifacts_read"
      end
      # resource path
      local_var_path = "{artifact_href}".sub('{' + 'artifact_href' + '}', artifact_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Artifact')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#artifacts_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for FileContent.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [FileContent]
    def content_file_files_create(data, opts = {})
      data, _status_code, _headers = content_file_files_create_with_http_info(data, opts)
      return data
    end

    # 
    # ViewSet for FileContent.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileContent, Fixnum, Hash)>] FileContent data, response status code and response headers
    def content_file_files_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.content_file_files_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.content_file_files_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/content/file/files/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileContent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#content_file_files_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for FileContent.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :digest Filter results where digest matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2001]
    def content_file_files_list(opts = {})
      data, _status_code, _headers = content_file_files_list_with_http_info(opts)
      return data
    end

    # 
    # ViewSet for FileContent.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :digest Filter results where digest matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2001, Fixnum, Hash)>] InlineResponse2001 data, response status code and response headers
    def content_file_files_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.content_file_files_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/content/file/files/"

      # query parameters
      query_params = {}
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'digest'] = opts[:'digest'] if !opts[:'digest'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2001')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#content_file_files_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for FileContent.
    # @param file_content_href URI of File Content. e.g.: /pulp/api/v3/content/file/files/1/
    # @param [Hash] opts the optional parameters
    # @return [FileContent]
    def content_file_files_read(file_content_href, opts = {})
      data, _status_code, _headers = content_file_files_read_with_http_info(file_content_href, opts)
      return data
    end

    # 
    # ViewSet for FileContent.
    # @param file_content_href URI of File Content. e.g.: /pulp/api/v3/content/file/files/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileContent, Fixnum, Hash)>] FileContent data, response status code and response headers
    def content_file_files_read_with_http_info(file_content_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.content_file_files_read ..."
      end
      # verify the required parameter 'file_content_href' is set
      if @api_client.config.client_side_validation && file_content_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_content_href' when calling PulpApi.content_file_files_read"
      end
      # resource path
      local_var_path = "{file_content_href}".sub('{' + 'file_content_href' + '}', file_content_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileContent')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#content_file_files_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous create task
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def distributions_create(data, opts = {})
      data, _status_code, _headers = distributions_create_with_http_info(data, opts)
      return data
    end

    # 
    # Trigger an asynchronous create task
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def distributions_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.distributions_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/distributions/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def distributions_delete(distribution_href, opts = {})
      distributions_delete_with_http_info(distribution_href, opts)
      return nil
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def distributions_delete_with_http_info(distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_delete ..."
      end
      # verify the required parameter 'distribution_href' is set
      if @api_client.config.client_side_validation && distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'distribution_href' when calling PulpApi.distributions_delete"
      end
      # resource path
      local_var_path = "{distribution_href}".sub('{' + 'distribution_href' + '}', distribution_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :base_path 
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [String] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2002]
    def distributions_list(opts = {})
      data, _status_code, _headers = distributions_list_with_http_info(opts)
      return data
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :base_path 
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [String] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2002, Fixnum, Hash)>] InlineResponse2002 data, response status code and response headers
    def distributions_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/distributions/"

      # query parameters
      query_params = {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'base_path'] = opts[:'base_path'] if !opts[:'base_path'].nil?
      query_params[:'base_path__contains'] = opts[:'base_path__contains'] if !opts[:'base_path__contains'].nil?
      query_params[:'base_path__icontains'] = opts[:'base_path__icontains'] if !opts[:'base_path__icontains'].nil?
      query_params[:'base_path__in'] = opts[:'base_path__in'] if !opts[:'base_path__in'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2002')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous partial update task
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def distributions_partial_update(distribution_href, data, opts = {})
      data, _status_code, _headers = distributions_partial_update_with_http_info(distribution_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous partial update task
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def distributions_partial_update_with_http_info(distribution_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_partial_update ..."
      end
      # verify the required parameter 'distribution_href' is set
      if @api_client.config.client_side_validation && distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'distribution_href' when calling PulpApi.distributions_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.distributions_partial_update"
      end
      # resource path
      local_var_path = "{distribution_href}".sub('{' + 'distribution_href' + '}', distribution_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param [Hash] opts the optional parameters
    # @return [Distribution]
    def distributions_read(distribution_href, opts = {})
      data, _status_code, _headers = distributions_read_with_http_info(distribution_href, opts)
      return data
    end

    # 
    # Provides read and list methods and also provides asynchronous CUD methods to dispatch tasks with reservation that lock all Distributions preventing race conditions during base_path checking.
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Distribution, Fixnum, Hash)>] Distribution data, response status code and response headers
    def distributions_read_with_http_info(distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_read ..."
      end
      # verify the required parameter 'distribution_href' is set
      if @api_client.config.client_side_validation && distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'distribution_href' when calling PulpApi.distributions_read"
      end
      # resource path
      local_var_path = "{distribution_href}".sub('{' + 'distribution_href' + '}', distribution_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Distribution')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous update task
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def distributions_update(distribution_href, data, opts = {})
      data, _status_code, _headers = distributions_update_with_http_info(distribution_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous update task
    # @param distribution_href URI of Distribution. e.g.: /pulp/api/v3/distributions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def distributions_update_with_http_info(distribution_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.distributions_update ..."
      end
      # verify the required parameter 'distribution_href' is set
      if @api_client.config.client_side_validation && distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'distribution_href' when calling PulpApi.distributions_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.distributions_update"
      end
      # resource path
      local_var_path = "{distribution_href}".sub('{' + 'distribution_href' + '}', distribution_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#distributions_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Cleans up all the Content and Artifact orphans in the system
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def orphans_delete(opts = {})
      orphans_delete_with_http_info(opts)
      return nil
    end

    # 
    # Cleans up all the Content and Artifact orphans in the system
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def orphans_delete_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.orphans_delete ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/orphans/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#orphans_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param publication_href URI of Publication. e.g.: /pulp/api/v3/publications/1/
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def publications_delete(publication_href, opts = {})
      publications_delete_with_http_info(publication_href, opts)
      return nil
    end

    # 
    # 
    # @param publication_href URI of Publication. e.g.: /pulp/api/v3/publications/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def publications_delete_with_http_info(publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publications_delete ..."
      end
      # verify the required parameter 'publication_href' is set
      if @api_client.config.client_side_validation && publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'publication_href' when calling PulpApi.publications_delete"
      end
      # resource path
      local_var_path = "{publication_href}".sub('{' + 'publication_href' + '}', publication_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publications_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2003]
    def publications_list(opts = {})
      data, _status_code, _headers = publications_list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2003, Fixnum, Hash)>] InlineResponse2003 data, response status code and response headers
    def publications_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publications_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/publications/"

      # query parameters
      query_params = {}
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2003')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publications_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param publication_href URI of Publication. e.g.: /pulp/api/v3/publications/1/
    # @param [Hash] opts the optional parameters
    # @return [Publication]
    def publications_read(publication_href, opts = {})
      data, _status_code, _headers = publications_read_with_http_info(publication_href, opts)
      return data
    end

    # 
    # 
    # @param publication_href URI of Publication. e.g.: /pulp/api/v3/publications/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Publication, Fixnum, Hash)>] Publication data, response status code and response headers
    def publications_read_with_http_info(publication_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publications_read ..."
      end
      # verify the required parameter 'publication_href' is set
      if @api_client.config.client_side_validation && publication_href.nil?
        fail ArgumentError, "Missing the required parameter 'publication_href' when calling PulpApi.publications_read"
      end
      # resource path
      local_var_path = "{publication_href}".sub('{' + 'publication_href' + '}', publication_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Publication')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publications_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Publishers.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [FilePublisher]
    def publishers_file_file_create(data, opts = {})
      data, _status_code, _headers = publishers_file_file_create_with_http_info(data, opts)
      return data
    end

    # 
    # ViewSet for File Publishers.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FilePublisher, Fixnum, Hash)>] FilePublisher data, response status code and response headers
    def publishers_file_file_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.publishers_file_file_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/publishers/file/file/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FilePublisher')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous delete task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def publishers_file_file_delete(file_publisher_href, opts = {})
      data, _status_code, _headers = publishers_file_file_delete_with_http_info(file_publisher_href, opts)
      return data
    end

    # 
    # Trigger an asynchronous delete task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def publishers_file_file_delete_with_http_info(file_publisher_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_delete ..."
      end
      # verify the required parameter 'file_publisher_href' is set
      if @api_client.config.client_side_validation && file_publisher_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_publisher_href' when calling PulpApi.publishers_file_file_delete"
      end
      # resource path
      local_var_path = "{file_publisher_href}".sub('{' + 'file_publisher_href' + '}', file_publisher_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Publishers.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :_last_updated__lt Filter results where _last_updated is less than value
    # @option opts [String] :_last_updated__lte Filter results where _last_updated is less than or equal to value
    # @option opts [String] :_last_updated__gt Filter results where _last_updated is greater than value
    # @option opts [String] :_last_updated__gte Filter results where _last_updated is greater than or equal to value
    # @option opts [String] :_last_updated__range Filter results where _last_updated is between two comma separated values
    # @option opts [String] :_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2004]
    def publishers_file_file_list(opts = {})
      data, _status_code, _headers = publishers_file_file_list_with_http_info(opts)
      return data
    end

    # 
    # ViewSet for File Publishers.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :_last_updated__lt Filter results where _last_updated is less than value
    # @option opts [String] :_last_updated__lte Filter results where _last_updated is less than or equal to value
    # @option opts [String] :_last_updated__gt Filter results where _last_updated is greater than value
    # @option opts [String] :_last_updated__gte Filter results where _last_updated is greater than or equal to value
    # @option opts [String] :_last_updated__range Filter results where _last_updated is between two comma separated values
    # @option opts [String] :_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2004, Fixnum, Hash)>] InlineResponse2004 data, response status code and response headers
    def publishers_file_file_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/publishers/file/file/"

      # query parameters
      query_params = {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'_last_updated__lt'] = opts[:'_last_updated__lt'] if !opts[:'_last_updated__lt'].nil?
      query_params[:'_last_updated__lte'] = opts[:'_last_updated__lte'] if !opts[:'_last_updated__lte'].nil?
      query_params[:'_last_updated__gt'] = opts[:'_last_updated__gt'] if !opts[:'_last_updated__gt'].nil?
      query_params[:'_last_updated__gte'] = opts[:'_last_updated__gte'] if !opts[:'_last_updated__gte'].nil?
      query_params[:'_last_updated__range'] = opts[:'_last_updated__range'] if !opts[:'_last_updated__range'].nil?
      query_params[:'_last_updated'] = opts[:'_last_updated'] if !opts[:'_last_updated'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2004')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous partial update task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def publishers_file_file_partial_update(file_publisher_href, data, opts = {})
      data, _status_code, _headers = publishers_file_file_partial_update_with_http_info(file_publisher_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous partial update task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def publishers_file_file_partial_update_with_http_info(file_publisher_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_partial_update ..."
      end
      # verify the required parameter 'file_publisher_href' is set
      if @api_client.config.client_side_validation && file_publisher_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_publisher_href' when calling PulpApi.publishers_file_file_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.publishers_file_file_partial_update"
      end
      # resource path
      local_var_path = "{file_publisher_href}".sub('{' + 'file_publisher_href' + '}', file_publisher_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to publish file content.
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def publishers_file_file_publish(file_publisher_href, data, opts = {})
      data, _status_code, _headers = publishers_file_file_publish_with_http_info(file_publisher_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to publish file content.
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def publishers_file_file_publish_with_http_info(file_publisher_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_publish ..."
      end
      # verify the required parameter 'file_publisher_href' is set
      if @api_client.config.client_side_validation && file_publisher_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_publisher_href' when calling PulpApi.publishers_file_file_publish"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.publishers_file_file_publish"
      end
      # resource path
      local_var_path = "{file_publisher_href}publish/".sub('{' + 'file_publisher_href' + '}', file_publisher_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_publish\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Publishers.
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [FilePublisher]
    def publishers_file_file_read(file_publisher_href, opts = {})
      data, _status_code, _headers = publishers_file_file_read_with_http_info(file_publisher_href, opts)
      return data
    end

    # 
    # ViewSet for File Publishers.
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(FilePublisher, Fixnum, Hash)>] FilePublisher data, response status code and response headers
    def publishers_file_file_read_with_http_info(file_publisher_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_read ..."
      end
      # verify the required parameter 'file_publisher_href' is set
      if @api_client.config.client_side_validation && file_publisher_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_publisher_href' when calling PulpApi.publishers_file_file_read"
      end
      # resource path
      local_var_path = "{file_publisher_href}".sub('{' + 'file_publisher_href' + '}', file_publisher_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FilePublisher')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous update task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def publishers_file_file_update(file_publisher_href, data, opts = {})
      data, _status_code, _headers = publishers_file_file_update_with_http_info(file_publisher_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous update task
    # @param file_publisher_href URI of File Publisher. e.g.: /pulp/api/v3/publishers/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def publishers_file_file_update_with_http_info(file_publisher_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.publishers_file_file_update ..."
      end
      # verify the required parameter 'file_publisher_href' is set
      if @api_client.config.client_side_validation && file_publisher_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_publisher_href' when calling PulpApi.publishers_file_file_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.publishers_file_file_update"
      end
      # resource path
      local_var_path = "{file_publisher_href}".sub('{' + 'file_publisher_href' + '}', file_publisher_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#publishers_file_file_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Remotes.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [FileRemote]
    def remotes_file_file_create(data, opts = {})
      data, _status_code, _headers = remotes_file_file_create_with_http_info(data, opts)
      return data
    end

    # 
    # ViewSet for File Remotes.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileRemote, Fixnum, Hash)>] FileRemote data, response status code and response headers
    def remotes_file_file_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.remotes_file_file_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/remotes/file/file/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileRemote')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous delete task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remotes_file_file_delete(file_remote_href, opts = {})
      data, _status_code, _headers = remotes_file_file_delete_with_http_info(file_remote_href, opts)
      return data
    end

    # 
    # Trigger an asynchronous delete task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remotes_file_file_delete_with_http_info(file_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_delete ..."
      end
      # verify the required parameter 'file_remote_href' is set
      if @api_client.config.client_side_validation && file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_remote_href' when calling PulpApi.remotes_file_file_delete"
      end
      # resource path
      local_var_path = "{file_remote_href}".sub('{' + 'file_remote_href' + '}', file_remote_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Remotes.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :_last_updated__lt Filter results where _last_updated is less than value
    # @option opts [String] :_last_updated__lte Filter results where _last_updated is less than or equal to value
    # @option opts [String] :_last_updated__gt Filter results where _last_updated is greater than value
    # @option opts [String] :_last_updated__gte Filter results where _last_updated is greater than or equal to value
    # @option opts [String] :_last_updated__range Filter results where _last_updated is between two comma separated values
    # @option opts [String] :_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2005]
    def remotes_file_file_list(opts = {})
      data, _status_code, _headers = remotes_file_file_list_with_http_info(opts)
      return data
    end

    # 
    # ViewSet for File Remotes.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :_last_updated__lt Filter results where _last_updated is less than value
    # @option opts [String] :_last_updated__lte Filter results where _last_updated is less than or equal to value
    # @option opts [String] :_last_updated__gt Filter results where _last_updated is greater than value
    # @option opts [String] :_last_updated__gte Filter results where _last_updated is greater than or equal to value
    # @option opts [String] :_last_updated__range Filter results where _last_updated is between two comma separated values
    # @option opts [String] :_last_updated ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2005, Fixnum, Hash)>] InlineResponse2005 data, response status code and response headers
    def remotes_file_file_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/remotes/file/file/"

      # query parameters
      query_params = {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'_last_updated__lt'] = opts[:'_last_updated__lt'] if !opts[:'_last_updated__lt'].nil?
      query_params[:'_last_updated__lte'] = opts[:'_last_updated__lte'] if !opts[:'_last_updated__lte'].nil?
      query_params[:'_last_updated__gt'] = opts[:'_last_updated__gt'] if !opts[:'_last_updated__gt'].nil?
      query_params[:'_last_updated__gte'] = opts[:'_last_updated__gte'] if !opts[:'_last_updated__gte'].nil?
      query_params[:'_last_updated__range'] = opts[:'_last_updated__range'] if !opts[:'_last_updated__range'].nil?
      query_params[:'_last_updated'] = opts[:'_last_updated'] if !opts[:'_last_updated'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2005')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous partial update task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remotes_file_file_partial_update(file_remote_href, data, opts = {})
      data, _status_code, _headers = remotes_file_file_partial_update_with_http_info(file_remote_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous partial update task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remotes_file_file_partial_update_with_http_info(file_remote_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_partial_update ..."
      end
      # verify the required parameter 'file_remote_href' is set
      if @api_client.config.client_side_validation && file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_remote_href' when calling PulpApi.remotes_file_file_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.remotes_file_file_partial_update"
      end
      # resource path
      local_var_path = "{file_remote_href}".sub('{' + 'file_remote_href' + '}', file_remote_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # ViewSet for File Remotes.
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [FileRemote]
    def remotes_file_file_read(file_remote_href, opts = {})
      data, _status_code, _headers = remotes_file_file_read_with_http_info(file_remote_href, opts)
      return data
    end

    # 
    # ViewSet for File Remotes.
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileRemote, Fixnum, Hash)>] FileRemote data, response status code and response headers
    def remotes_file_file_read_with_http_info(file_remote_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_read ..."
      end
      # verify the required parameter 'file_remote_href' is set
      if @api_client.config.client_side_validation && file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_remote_href' when calling PulpApi.remotes_file_file_read"
      end
      # resource path
      local_var_path = "{file_remote_href}".sub('{' + 'file_remote_href' + '}', file_remote_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileRemote')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to sync file content.
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remotes_file_file_sync(file_remote_href, data, opts = {})
      data, _status_code, _headers = remotes_file_file_sync_with_http_info(file_remote_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to sync file content.
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remotes_file_file_sync_with_http_info(file_remote_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_sync ..."
      end
      # verify the required parameter 'file_remote_href' is set
      if @api_client.config.client_side_validation && file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_remote_href' when calling PulpApi.remotes_file_file_sync"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.remotes_file_file_sync"
      end
      # resource path
      local_var_path = "{file_remote_href}sync/".sub('{' + 'file_remote_href' + '}', file_remote_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous update task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remotes_file_file_update(file_remote_href, data, opts = {})
      data, _status_code, _headers = remotes_file_file_update_with_http_info(file_remote_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous update task
    # @param file_remote_href URI of File Remote. e.g.: /pulp/api/v3/remotes/file/file/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remotes_file_file_update_with_http_info(file_remote_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.remotes_file_file_update ..."
      end
      # verify the required parameter 'file_remote_href' is set
      if @api_client.config.client_side_validation && file_remote_href.nil?
        fail ArgumentError, "Missing the required parameter 'file_remote_href' when calling PulpApi.remotes_file_file_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.remotes_file_file_update"
      end
      # resource path
      local_var_path = "{file_remote_href}".sub('{' + 'file_remote_href' + '}', file_remote_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#remotes_file_file_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Repository]
    def repositories_create(data, opts = {})
      data, _status_code, _headers = repositories_create_with_http_info(data, opts)
      return data
    end

    # 
    # 
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Repository, Fixnum, Hash)>] Repository data, response status code and response headers
    def repositories_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/repositories/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Repository')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to delete a repository.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def repositories_delete(repository_href, opts = {})
      data, _status_code, _headers = repositories_delete_with_http_info(repository_href, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to delete a repository.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def repositories_delete_with_http_info(repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_delete ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_delete"
      end
      # resource path
      local_var_path = "{repository_href}".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2006]
    def repositories_list(opts = {})
      data, _status_code, _headers = repositories_list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2006, Fixnum, Hash)>] InlineResponse2006 data, response status code and response headers
    def repositories_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/repositories/"

      # query parameters
      query_params = {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2006')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Repository]
    def repositories_partial_update(repository_href, data, opts = {})
      data, _status_code, _headers = repositories_partial_update_with_http_info(repository_href, data, opts)
      return data
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Repository, Fixnum, Hash)>] Repository data, response status code and response headers
    def repositories_partial_update_with_http_info(repository_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_partial_update ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_partial_update"
      end
      # resource path
      local_var_path = "{repository_href}".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Repository')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @return [Repository]
    def repositories_read(repository_href, opts = {})
      data, _status_code, _headers = repositories_read_with_http_info(repository_href, opts)
      return data
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Repository, Fixnum, Hash)>] Repository data, response status code and response headers
    def repositories_read_with_http_info(repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_read ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_read"
      end
      # resource path
      local_var_path = "{repository_href}".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Repository')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to updatea repository.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def repositories_update(repository_href, data, opts = {})
      data, _status_code, _headers = repositories_update_with_http_info(repository_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to updatea repository.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def repositories_update_with_http_info(repository_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_update ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_update"
      end
      # resource path
      local_var_path = "{repository_href}".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to create a new repository version.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def repositories_versions_create(repository_href, data, opts = {})
      data, _status_code, _headers = repositories_versions_create_with_http_info(repository_href, data, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to create a new repository version.
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def repositories_versions_create_with_http_info(repository_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_create ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_versions_create"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_versions_create"
      end
      # resource path
      local_var_path = "{repository_href}versions/".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Trigger an asynchronous task to delete a repositroy version.
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def repositories_versions_delete(repository_version_href, opts = {})
      data, _status_code, _headers = repositories_versions_delete_with_http_info(repository_version_href, opts)
      return data
    end

    # 
    # Trigger an asynchronous task to delete a repositroy version.
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Fixnum, Hash)>] AsyncOperationResponse data, response status code and response headers
    def repositories_versions_delete_with_http_info(repository_version_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_delete ..."
      end
      # verify the required parameter 'repository_version_href' is set
      if @api_client.config.client_side_validation && repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_version_href' when calling PulpApi.repositories_versions_delete"
      end
      # resource path
      local_var_path = "{repository_version_href}".sub('{' + 'repository_version_href' + '}', repository_version_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AsyncOperationResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [Float] :number 
    # @option opts [Float] :number__lt Filter results where number is less than value
    # @option opts [Float] :number__lte Filter results where number is less than or equal to value
    # @option opts [Float] :number__gt Filter results where number is greater than value
    # @option opts [Float] :number__gte Filter results where number is greater than or equal to value
    # @option opts [Float] :number__range Filter results where number is between two comma separated values
    # @option opts [String] :_created__lt Filter results where _created is less than value
    # @option opts [String] :_created__lte Filter results where _created is less than or equal to value
    # @option opts [String] :_created__gt Filter results where _created is greater than value
    # @option opts [String] :_created__gte Filter results where _created is greater than or equal to value
    # @option opts [String] :_created__range Filter results where _created is between two comma separated values
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :_created ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2007]
    def repositories_versions_list(repository_href, opts = {})
      data, _status_code, _headers = repositories_versions_list_with_http_info(repository_href, opts)
      return data
    end

    # 
    # 
    # @param repository_href URI of Repository. e.g.: /pulp/api/v3/repositories/1/
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [Float] :number 
    # @option opts [Float] :number__lt Filter results where number is less than value
    # @option opts [Float] :number__lte Filter results where number is less than or equal to value
    # @option opts [Float] :number__gt Filter results where number is greater than value
    # @option opts [Float] :number__gte Filter results where number is greater than or equal to value
    # @option opts [Float] :number__range Filter results where number is between two comma separated values
    # @option opts [String] :_created__lt Filter results where _created is less than value
    # @option opts [String] :_created__lte Filter results where _created is less than or equal to value
    # @option opts [String] :_created__gt Filter results where _created is greater than value
    # @option opts [String] :_created__gte Filter results where _created is greater than or equal to value
    # @option opts [String] :_created__range Filter results where _created is between two comma separated values
    # @option opts [String] :content Content Unit referenced by HREF
    # @option opts [String] :_created ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2007, Fixnum, Hash)>] InlineResponse2007 data, response status code and response headers
    def repositories_versions_list_with_http_info(repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_list ..."
      end
      # verify the required parameter 'repository_href' is set
      if @api_client.config.client_side_validation && repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_href' when calling PulpApi.repositories_versions_list"
      end
      # resource path
      local_var_path = "{repository_href}versions/".sub('{' + 'repository_href' + '}', repository_href.to_s)

      # query parameters
      query_params = {}
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'number'] = opts[:'number'] if !opts[:'number'].nil?
      query_params[:'number__lt'] = opts[:'number__lt'] if !opts[:'number__lt'].nil?
      query_params[:'number__lte'] = opts[:'number__lte'] if !opts[:'number__lte'].nil?
      query_params[:'number__gt'] = opts[:'number__gt'] if !opts[:'number__gt'].nil?
      query_params[:'number__gte'] = opts[:'number__gte'] if !opts[:'number__gte'].nil?
      query_params[:'number__range'] = opts[:'number__range'] if !opts[:'number__range'].nil?
      query_params[:'_created__lt'] = opts[:'_created__lt'] if !opts[:'_created__lt'].nil?
      query_params[:'_created__lte'] = opts[:'_created__lte'] if !opts[:'_created__lte'].nil?
      query_params[:'_created__gt'] = opts[:'_created__gt'] if !opts[:'_created__gt'].nil?
      query_params[:'_created__gte'] = opts[:'_created__gte'] if !opts[:'_created__gte'].nil?
      query_params[:'_created__range'] = opts[:'_created__range'] if !opts[:'_created__range'].nil?
      query_params[:'content'] = opts[:'content'] if !opts[:'content'].nil?
      query_params[:'_created'] = opts[:'_created'] if !opts[:'_created'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2007')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [RepositoryVersion]
    def repositories_versions_partial_update(repository_version_href, data, opts = {})
      data, _status_code, _headers = repositories_versions_partial_update_with_http_info(repository_version_href, data, opts)
      return data
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RepositoryVersion, Fixnum, Hash)>] RepositoryVersion data, response status code and response headers
    def repositories_versions_partial_update_with_http_info(repository_version_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_partial_update ..."
      end
      # verify the required parameter 'repository_version_href' is set
      if @api_client.config.client_side_validation && repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_version_href' when calling PulpApi.repositories_versions_partial_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_versions_partial_update"
      end
      # resource path
      local_var_path = "{repository_version_href}".sub('{' + 'repository_version_href' + '}', repository_version_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RepositoryVersion')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param [Hash] opts the optional parameters
    # @return [RepositoryVersion]
    def repositories_versions_read(repository_version_href, opts = {})
      data, _status_code, _headers = repositories_versions_read_with_http_info(repository_version_href, opts)
      return data
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(RepositoryVersion, Fixnum, Hash)>] RepositoryVersion data, response status code and response headers
    def repositories_versions_read_with_http_info(repository_version_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_read ..."
      end
      # verify the required parameter 'repository_version_href' is set
      if @api_client.config.client_side_validation && repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_version_href' when calling PulpApi.repositories_versions_read"
      end
      # resource path
      local_var_path = "{repository_version_href}".sub('{' + 'repository_version_href' + '}', repository_version_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RepositoryVersion')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [RepositoryVersion]
    def repositories_versions_update(repository_version_href, data, opts = {})
      data, _status_code, _headers = repositories_versions_update_with_http_info(repository_version_href, data, opts)
      return data
    end

    # 
    # 
    # @param repository_version_href URI of Repository Version. e.g.: /pulp/api/v3/repositories/1/versions/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(RepositoryVersion, Fixnum, Hash)>] RepositoryVersion data, response status code and response headers
    def repositories_versions_update_with_http_info(repository_version_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.repositories_versions_update ..."
      end
      # verify the required parameter 'repository_version_href' is set
      if @api_client.config.client_side_validation && repository_version_href.nil?
        fail ArgumentError, "Missing the required parameter 'repository_version_href' when calling PulpApi.repositories_versions_update"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.repositories_versions_update"
      end
      # resource path
      local_var_path = "{repository_version_href}".sub('{' + 'repository_version_href' + '}', repository_version_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'RepositoryVersion')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#repositories_versions_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Returns app information including the version of pulpcore and loaded pulp plugins, known workers, database connection status, and messaging connection status
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def status_list(opts = {})
      status_list_with_http_info(opts)
      return nil
    end

    # 
    # Returns app information including the version of pulpcore and loaded pulp plugins, known workers, database connection status, and messaging connection status
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def status_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.status_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/status/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#status_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Task]
    def tasks_cancel(task_href, data, opts = {})
      data, _status_code, _headers = tasks_cancel_with_http_info(task_href, data, opts)
      return data
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Task, Fixnum, Hash)>] Task data, response status code and response headers
    def tasks_cancel_with_http_info(task_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.tasks_cancel ..."
      end
      # verify the required parameter 'task_href' is set
      if @api_client.config.client_side_validation && task_href.nil?
        fail ArgumentError, "Missing the required parameter 'task_href' when calling PulpApi.tasks_cancel"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.tasks_cancel"
      end
      # resource path
      local_var_path = "{task_href}cancel/".sub('{' + 'task_href' + '}', task_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Task')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#tasks_cancel\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def tasks_delete(task_href, opts = {})
      tasks_delete_with_http_info(task_href, opts)
      return nil
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def tasks_delete_with_http_info(task_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.tasks_delete ..."
      end
      # verify the required parameter 'task_href' is set
      if @api_client.config.client_side_validation && task_href.nil?
        fail ArgumentError, "Missing the required parameter 'task_href' when calling PulpApi.tasks_delete"
      end
      # resource path
      local_var_path = "{task_href}".sub('{' + 'task_href' + '}', task_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#tasks_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :state 
    # @option opts [String] :state__in Filter results where state is in a comma-separated list of values
    # @option opts [String] :worker Foreign Key referenced by HREF
    # @option opts [String] :worker__in Filter results where worker is in a comma-separated list of values
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :started_at__lt Filter results where started_at is less than value
    # @option opts [String] :started_at__lte Filter results where started_at is less than or equal to value
    # @option opts [String] :started_at__gt Filter results where started_at is greater than value
    # @option opts [String] :started_at__gte Filter results where started_at is greater than or equal to value
    # @option opts [String] :started_at__range Filter results where started_at is between two comma separated values
    # @option opts [String] :finished_at__lt Filter results where finished_at is less than value
    # @option opts [String] :finished_at__lte Filter results where finished_at is less than or equal to value
    # @option opts [String] :finished_at__gt Filter results where finished_at is greater than value
    # @option opts [String] :finished_at__gte Filter results where finished_at is greater than or equal to value
    # @option opts [String] :finished_at__range Filter results where finished_at is between two comma separated values
    # @option opts [String] :parent Foreign Key referenced by HREF
    # @option opts [String] :name 
    # @option opts [String] :started_at ISO 8601 formatted dates are supported
    # @option opts [String] :finished_at ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2008]
    def tasks_list(opts = {})
      data, _status_code, _headers = tasks_list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :state 
    # @option opts [String] :state__in Filter results where state is in a comma-separated list of values
    # @option opts [String] :worker Foreign Key referenced by HREF
    # @option opts [String] :worker__in Filter results where worker is in a comma-separated list of values
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :started_at__lt Filter results where started_at is less than value
    # @option opts [String] :started_at__lte Filter results where started_at is less than or equal to value
    # @option opts [String] :started_at__gt Filter results where started_at is greater than value
    # @option opts [String] :started_at__gte Filter results where started_at is greater than or equal to value
    # @option opts [String] :started_at__range Filter results where started_at is between two comma separated values
    # @option opts [String] :finished_at__lt Filter results where finished_at is less than value
    # @option opts [String] :finished_at__lte Filter results where finished_at is less than or equal to value
    # @option opts [String] :finished_at__gt Filter results where finished_at is greater than value
    # @option opts [String] :finished_at__gte Filter results where finished_at is greater than or equal to value
    # @option opts [String] :finished_at__range Filter results where finished_at is between two comma separated values
    # @option opts [String] :parent Foreign Key referenced by HREF
    # @option opts [String] :name 
    # @option opts [String] :started_at ISO 8601 formatted dates are supported
    # @option opts [String] :finished_at ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2008, Fixnum, Hash)>] InlineResponse2008 data, response status code and response headers
    def tasks_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.tasks_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/tasks/"

      # query parameters
      query_params = {}
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'state'] = opts[:'state'] if !opts[:'state'].nil?
      query_params[:'state__in'] = opts[:'state__in'] if !opts[:'state__in'].nil?
      query_params[:'worker'] = opts[:'worker'] if !opts[:'worker'].nil?
      query_params[:'worker__in'] = opts[:'worker__in'] if !opts[:'worker__in'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'started_at__lt'] = opts[:'started_at__lt'] if !opts[:'started_at__lt'].nil?
      query_params[:'started_at__lte'] = opts[:'started_at__lte'] if !opts[:'started_at__lte'].nil?
      query_params[:'started_at__gt'] = opts[:'started_at__gt'] if !opts[:'started_at__gt'].nil?
      query_params[:'started_at__gte'] = opts[:'started_at__gte'] if !opts[:'started_at__gte'].nil?
      query_params[:'started_at__range'] = opts[:'started_at__range'] if !opts[:'started_at__range'].nil?
      query_params[:'finished_at__lt'] = opts[:'finished_at__lt'] if !opts[:'finished_at__lt'].nil?
      query_params[:'finished_at__lte'] = opts[:'finished_at__lte'] if !opts[:'finished_at__lte'].nil?
      query_params[:'finished_at__gt'] = opts[:'finished_at__gt'] if !opts[:'finished_at__gt'].nil?
      query_params[:'finished_at__gte'] = opts[:'finished_at__gte'] if !opts[:'finished_at__gte'].nil?
      query_params[:'finished_at__range'] = opts[:'finished_at__range'] if !opts[:'finished_at__range'].nil?
      query_params[:'parent'] = opts[:'parent'] if !opts[:'parent'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'started_at'] = opts[:'started_at'] if !opts[:'started_at'].nil?
      query_params[:'finished_at'] = opts[:'finished_at'] if !opts[:'finished_at'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2008')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#tasks_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param [Hash] opts the optional parameters
    # @return [Task]
    def tasks_read(task_href, opts = {})
      data, _status_code, _headers = tasks_read_with_http_info(task_href, opts)
      return data
    end

    # 
    # 
    # @param task_href URI of Task. e.g.: /pulp/api/v3/tasks/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Task, Fixnum, Hash)>] Task data, response status code and response headers
    def tasks_read_with_http_info(task_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.tasks_read ..."
      end
      # verify the required parameter 'task_href' is set
      if @api_client.config.client_side_validation && task_href.nil?
        fail ArgumentError, "Missing the required parameter 'task_href' when calling PulpApi.tasks_read"
      end
      # resource path
      local_var_path = "{task_href}".sub('{' + 'task_href' + '}', task_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Task')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#tasks_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle POST requests.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_create(data, opts = {})
      data, _status_code, _headers = uploads_create_with_http_info(data, opts)
      return data
    end

    # 
    # Handle POST requests.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_create_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_create ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.uploads_create"
      end
      # resource path
      local_var_path = "/pulp/api/v3/uploads/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle POST requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_create_0(upload_href, data, opts = {})
      data, _status_code, _headers = uploads_create_0_with_http_info(upload_href, data, opts)
      return data
    end

    # 
    # Handle POST requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_create_0_with_http_info(upload_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_create_0 ..."
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling PulpApi.uploads_create_0"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.uploads_create_0"
      end
      # resource path
      local_var_path = "{upload_href}".sub('{' + 'upload_href' + '}', upload_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_create_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle GET requests.
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_read(opts = {})
      data, _status_code, _headers = uploads_read_with_http_info(opts)
      return data
    end

    # 
    # Handle GET requests.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_read_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_read ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/uploads/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle GET requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_read_0(upload_href, opts = {})
      data, _status_code, _headers = uploads_read_0_with_http_info(upload_href, opts)
      return data
    end

    # 
    # Handle GET requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_read_0_with_http_info(upload_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_read_0 ..."
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling PulpApi.uploads_read_0"
      end
      # resource path
      local_var_path = "{upload_href}".sub('{' + 'upload_href' + '}', upload_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_read_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle PUT requests.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_update(data, opts = {})
      data, _status_code, _headers = uploads_update_with_http_info(data, opts)
      return data
    end

    # 
    # Handle PUT requests.
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_update_with_http_info(data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_update ..."
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.uploads_update"
      end
      # resource path
      local_var_path = "/pulp/api/v3/uploads/"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # Handle PUT requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Upload]
    def uploads_update_0(upload_href, data, opts = {})
      data, _status_code, _headers = uploads_update_0_with_http_info(upload_href, data, opts)
      return data
    end

    # 
    # Handle PUT requests.
    # @param upload_href URI of Upload. e.g.: /pulp/api/v3/uploads/1/
    # @param data 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Upload, Fixnum, Hash)>] Upload data, response status code and response headers
    def uploads_update_0_with_http_info(upload_href, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.uploads_update_0 ..."
      end
      # verify the required parameter 'upload_href' is set
      if @api_client.config.client_side_validation && upload_href.nil?
        fail ArgumentError, "Missing the required parameter 'upload_href' when calling PulpApi.uploads_update_0"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling PulpApi.uploads_update_0"
      end
      # resource path
      local_var_path = "{upload_href}".sub('{' + 'upload_href' + '}', upload_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Upload')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#uploads_update_0\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :last_heartbeat__lt Filter results where last_heartbeat is less than value
    # @option opts [String] :last_heartbeat__lte Filter results where last_heartbeat is less than or equal to value
    # @option opts [String] :last_heartbeat__gt Filter results where last_heartbeat is greater than value
    # @option opts [String] :last_heartbeat__gte Filter results where last_heartbeat is greater than or equal to value
    # @option opts [String] :last_heartbeat__range Filter results where last_heartbeat is between two comma separated values
    # @option opts [String] :online 
    # @option opts [String] :missing 
    # @option opts [String] :last_heartbeat ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [InlineResponse2009]
    def workers_list(opts = {})
      data, _status_code, _headers = workers_list_with_http_info(opts)
      return data
    end

    # 
    # 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :name 
    # @option opts [String] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :last_heartbeat__lt Filter results where last_heartbeat is less than value
    # @option opts [String] :last_heartbeat__lte Filter results where last_heartbeat is less than or equal to value
    # @option opts [String] :last_heartbeat__gt Filter results where last_heartbeat is greater than value
    # @option opts [String] :last_heartbeat__gte Filter results where last_heartbeat is greater than or equal to value
    # @option opts [String] :last_heartbeat__range Filter results where last_heartbeat is between two comma separated values
    # @option opts [String] :online 
    # @option opts [String] :missing 
    # @option opts [String] :last_heartbeat ISO 8601 formatted dates are supported
    # @option opts [Integer] :page A page number within the paginated result set.
    # @option opts [Integer] :page_size Number of results to return per page.
    # @return [Array<(InlineResponse2009, Fixnum, Hash)>] InlineResponse2009 data, response status code and response headers
    def workers_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.workers_list ..."
      end
      # resource path
      local_var_path = "/pulp/api/v3/workers/"

      # query parameters
      query_params = {}
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = opts[:'name__in'] if !opts[:'name__in'].nil?
      query_params[:'last_heartbeat__lt'] = opts[:'last_heartbeat__lt'] if !opts[:'last_heartbeat__lt'].nil?
      query_params[:'last_heartbeat__lte'] = opts[:'last_heartbeat__lte'] if !opts[:'last_heartbeat__lte'].nil?
      query_params[:'last_heartbeat__gt'] = opts[:'last_heartbeat__gt'] if !opts[:'last_heartbeat__gt'].nil?
      query_params[:'last_heartbeat__gte'] = opts[:'last_heartbeat__gte'] if !opts[:'last_heartbeat__gte'].nil?
      query_params[:'last_heartbeat__range'] = opts[:'last_heartbeat__range'] if !opts[:'last_heartbeat__range'].nil?
      query_params[:'online'] = opts[:'online'] if !opts[:'online'].nil?
      query_params[:'missing'] = opts[:'missing'] if !opts[:'missing'].nil?
      query_params[:'last_heartbeat'] = opts[:'last_heartbeat'] if !opts[:'last_heartbeat'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'InlineResponse2009')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#workers_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param worker_href URI of Worker. e.g.: /pulp/api/v3/workers/1/
    # @param [Hash] opts the optional parameters
    # @return [Worker]
    def workers_read(worker_href, opts = {})
      data, _status_code, _headers = workers_read_with_http_info(worker_href, opts)
      return data
    end

    # 
    # 
    # @param worker_href URI of Worker. e.g.: /pulp/api/v3/workers/1/
    # @param [Hash] opts the optional parameters
    # @return [Array<(Worker, Fixnum, Hash)>] Worker data, response status code and response headers
    def workers_read_with_http_info(worker_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: PulpApi.workers_read ..."
      end
      # verify the required parameter 'worker_href' is set
      if @api_client.config.client_side_validation && worker_href.nil?
        fail ArgumentError, "Missing the required parameter 'worker_href' when calling PulpApi.workers_read"
      end
      # resource path
      local_var_path = "{worker_href}".sub('{' + 'worker_href' + '}', worker_href.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['Basic']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Worker')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PulpApi#workers_read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
