=begin
#Pulp3 API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v3

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module Zest

  class FileRemote
    attr_accessor :_href

    # Timestamp of creation.
    attr_accessor :_created

    attr_accessor :_type

    # A unique name for this remote.
    attr_accessor :name

    # The URL of an external content source.
    attr_accessor :url

    # If True, the plugin will validate imported artifacts.
    attr_accessor :validate

    # A PEM encoded CA certificate used to validate the server certificate presented by the remote server.
    attr_accessor :ssl_ca_certificate

    # A PEM encoded client certificate used for authentication.
    attr_accessor :ssl_client_certificate

    # A PEM encoded private key used for authentication.
    attr_accessor :ssl_client_key

    # If True, SSL peer validation must be performed.
    attr_accessor :ssl_validation

    # The proxy URL. Format: scheme://user:password@host:port
    attr_accessor :proxy_url

    # The username to be used for authentication when syncing.
    attr_accessor :username

    # The password to be used for authentication when syncing.
    attr_accessor :password

    # Timestamp of the most recent update of the remote.
    attr_accessor :_last_updated

    # Total number of simultaneous connections.
    attr_accessor :download_concurrency

    # The policy to use when downloading content. The possible values include: 'immediate', 'on_demand', and 'cache_only'. 'immediate' is the default.
    attr_accessor :policy

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_href' => :'_href',
        :'_created' => :'_created',
        :'_type' => :'_type',
        :'name' => :'name',
        :'url' => :'url',
        :'validate' => :'validate',
        :'ssl_ca_certificate' => :'ssl_ca_certificate',
        :'ssl_client_certificate' => :'ssl_client_certificate',
        :'ssl_client_key' => :'ssl_client_key',
        :'ssl_validation' => :'ssl_validation',
        :'proxy_url' => :'proxy_url',
        :'username' => :'username',
        :'password' => :'password',
        :'_last_updated' => :'_last_updated',
        :'download_concurrency' => :'download_concurrency',
        :'policy' => :'policy'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_href' => :'String',
        :'_created' => :'DateTime',
        :'_type' => :'String',
        :'name' => :'String',
        :'url' => :'String',
        :'validate' => :'BOOLEAN',
        :'ssl_ca_certificate' => :'String',
        :'ssl_client_certificate' => :'String',
        :'ssl_client_key' => :'String',
        :'ssl_validation' => :'BOOLEAN',
        :'proxy_url' => :'String',
        :'username' => :'String',
        :'password' => :'String',
        :'_last_updated' => :'DateTime',
        :'download_concurrency' => :'Integer',
        :'policy' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_href')
        self._href = attributes[:'_href']
      end

      if attributes.has_key?(:'_created')
        self._created = attributes[:'_created']
      end

      if attributes.has_key?(:'_type')
        self._type = attributes[:'_type']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'validate')
        self.validate = attributes[:'validate']
      end

      if attributes.has_key?(:'ssl_ca_certificate')
        self.ssl_ca_certificate = attributes[:'ssl_ca_certificate']
      end

      if attributes.has_key?(:'ssl_client_certificate')
        self.ssl_client_certificate = attributes[:'ssl_client_certificate']
      end

      if attributes.has_key?(:'ssl_client_key')
        self.ssl_client_key = attributes[:'ssl_client_key']
      end

      if attributes.has_key?(:'ssl_validation')
        self.ssl_validation = attributes[:'ssl_validation']
      end

      if attributes.has_key?(:'proxy_url')
        self.proxy_url = attributes[:'proxy_url']
      end

      if attributes.has_key?(:'username')
        self.username = attributes[:'username']
      end

      if attributes.has_key?(:'password')
        self.password = attributes[:'password']
      end

      if attributes.has_key?(:'_last_updated')
        self._last_updated = attributes[:'_last_updated']
      end

      if attributes.has_key?(:'download_concurrency')
        self.download_concurrency = attributes[:'download_concurrency']
      end

      if attributes.has_key?(:'policy')
        self.policy = attributes[:'policy']
      else
        self.policy = "immediate"
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@_type.nil? && @_type.to_s.length < 1
        invalid_properties.push("invalid value for '_type', the character length must be great than or equal to 1.")
      end

      if @name.nil?
        invalid_properties.push("invalid value for 'name', name cannot be nil.")
      end

      if @name.to_s.length < 1
        invalid_properties.push("invalid value for 'name', the character length must be great than or equal to 1.")
      end

      if @url.nil?
        invalid_properties.push("invalid value for 'url', url cannot be nil.")
      end

      if @url.to_s.length < 1
        invalid_properties.push("invalid value for 'url', the character length must be great than or equal to 1.")
      end

      if !@download_concurrency.nil? && @download_concurrency < 1
        invalid_properties.push("invalid value for 'download_concurrency', must be greater than or equal to 1.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@_type.nil? && @_type.to_s.length < 1
      return false if @name.nil?
      return false if @name.to_s.length < 1
      return false if @url.nil?
      return false if @url.to_s.length < 1
      return false if !@download_concurrency.nil? && @download_concurrency < 1
      policy_validator = EnumAttributeValidator.new('String', ["immediate", "on_demand", "streamed"])
      return false unless policy_validator.valid?(@policy)
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] _type Value to be assigned
    def _type=(_type)

      if !_type.nil? && _type.to_s.length < 1
        fail ArgumentError, "invalid value for '_type', the character length must be great than or equal to 1."
      end

      @_type = _type
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if name.nil?
        fail ArgumentError, "name cannot be nil"
      end

      if name.to_s.length < 1
        fail ArgumentError, "invalid value for 'name', the character length must be great than or equal to 1."
      end

      @name = name
    end

    # Custom attribute writer method with validation
    # @param [Object] url Value to be assigned
    def url=(url)
      if url.nil?
        fail ArgumentError, "url cannot be nil"
      end

      if url.to_s.length < 1
        fail ArgumentError, "invalid value for 'url', the character length must be great than or equal to 1."
      end

      @url = url
    end

    # Custom attribute writer method with validation
    # @param [Object] download_concurrency Value to be assigned
    def download_concurrency=(download_concurrency)

      if !download_concurrency.nil? && download_concurrency < 1
        fail ArgumentError, "invalid value for 'download_concurrency', must be greater than or equal to 1."
      end

      @download_concurrency = download_concurrency
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] policy Object to be assigned
    def policy=(policy)
      validator = EnumAttributeValidator.new('String', ["immediate", "on_demand", "streamed"])
      unless validator.valid?(policy)
        fail ArgumentError, "invalid value for 'policy', must be one of #{validator.allowable_values}."
      end
      @policy = policy
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _href == o._href &&
          _created == o._created &&
          _type == o._type &&
          name == o.name &&
          url == o.url &&
          validate == o.validate &&
          ssl_ca_certificate == o.ssl_ca_certificate &&
          ssl_client_certificate == o.ssl_client_certificate &&
          ssl_client_key == o.ssl_client_key &&
          ssl_validation == o.ssl_validation &&
          proxy_url == o.proxy_url &&
          username == o.username &&
          password == o.password &&
          _last_updated == o._last_updated &&
          download_concurrency == o.download_concurrency &&
          policy == o.policy
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_href, _created, _type, name, url, validate, ssl_ca_certificate, ssl_client_certificate, ssl_client_key, ssl_validation, proxy_url, username, password, _last_updated, download_concurrency, policy].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Zest.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
