=begin
#Pulp3 API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v3

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module Zest

  class Task
    attr_accessor :_href

    # Timestamp of creation.
    attr_accessor :_created

    # The current state of the task. The possible values include: 'waiting', 'skipped', 'running', 'completed', 'failed' and 'canceled'.
    attr_accessor :state

    # The name of task.
    attr_accessor :name

    # Timestamp of the when this task started execution.
    attr_accessor :started_at

    # Timestamp of the when this task stopped execution.
    attr_accessor :finished_at

    # A JSON Object of non-fatal errors encountered during the execution of this task.
    attr_accessor :non_fatal_errors

    # A JSON Object of a fatal error encountered during the execution of this task.
    attr_accessor :error

    # The worker associated with this task. This field is empty if a worker is not yet assigned.
    attr_accessor :worker

    # The parent task that spawned this task.
    attr_accessor :parent

    # Any tasks spawned by this task.
    attr_accessor :spawned_tasks

    attr_accessor :progress_reports

    # Resources created by this task.
    attr_accessor :created_resources


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_href' => :'_href',
        :'_created' => :'_created',
        :'state' => :'state',
        :'name' => :'name',
        :'started_at' => :'started_at',
        :'finished_at' => :'finished_at',
        :'non_fatal_errors' => :'non_fatal_errors',
        :'error' => :'error',
        :'worker' => :'worker',
        :'parent' => :'parent',
        :'spawned_tasks' => :'spawned_tasks',
        :'progress_reports' => :'progress_reports',
        :'created_resources' => :'created_resources'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_href' => :'String',
        :'_created' => :'DateTime',
        :'state' => :'String',
        :'name' => :'String',
        :'started_at' => :'DateTime',
        :'finished_at' => :'DateTime',
        :'non_fatal_errors' => :'String',
        :'error' => :'String',
        :'worker' => :'String',
        :'parent' => :'String',
        :'spawned_tasks' => :'Array<String>',
        :'progress_reports' => :'Array<ProgressReport>',
        :'created_resources' => :'Array<String>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_href')
        self._href = attributes[:'_href']
      end

      if attributes.has_key?(:'_created')
        self._created = attributes[:'_created']
      end

      if attributes.has_key?(:'state')
        self.state = attributes[:'state']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'started_at')
        self.started_at = attributes[:'started_at']
      end

      if attributes.has_key?(:'finished_at')
        self.finished_at = attributes[:'finished_at']
      end

      if attributes.has_key?(:'non_fatal_errors')
        self.non_fatal_errors = attributes[:'non_fatal_errors']
      end

      if attributes.has_key?(:'error')
        self.error = attributes[:'error']
      end

      if attributes.has_key?(:'worker')
        self.worker = attributes[:'worker']
      end

      if attributes.has_key?(:'parent')
        self.parent = attributes[:'parent']
      end

      if attributes.has_key?(:'spawned_tasks')
        if (value = attributes[:'spawned_tasks']).is_a?(Array)
          self.spawned_tasks = value
        end
      end

      if attributes.has_key?(:'progress_reports')
        if (value = attributes[:'progress_reports']).is_a?(Array)
          self.progress_reports = value
        end
      end

      if attributes.has_key?(:'created_resources')
        if (value = attributes[:'created_resources']).is_a?(Array)
          self.created_resources = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@state.nil? && @state.to_s.length < 1
        invalid_properties.push("invalid value for 'state', the character length must be great than or equal to 1.")
      end

      if @name.nil?
        invalid_properties.push("invalid value for 'name', name cannot be nil.")
      end

      if @name.to_s.length < 1
        invalid_properties.push("invalid value for 'name', the character length must be great than or equal to 1.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@state.nil? && @state.to_s.length < 1
      return false if @name.nil?
      return false if @name.to_s.length < 1
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] state Value to be assigned
    def state=(state)

      if !state.nil? && state.to_s.length < 1
        fail ArgumentError, "invalid value for 'state', the character length must be great than or equal to 1."
      end

      @state = state
    end

    # Custom attribute writer method with validation
    # @param [Object] name Value to be assigned
    def name=(name)
      if name.nil?
        fail ArgumentError, "name cannot be nil"
      end

      if name.to_s.length < 1
        fail ArgumentError, "invalid value for 'name', the character length must be great than or equal to 1."
      end

      @name = name
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _href == o._href &&
          _created == o._created &&
          state == o.state &&
          name == o.name &&
          started_at == o.started_at &&
          finished_at == o.finished_at &&
          non_fatal_errors == o.non_fatal_errors &&
          error == o.error &&
          worker == o.worker &&
          parent == o.parent &&
          spawned_tasks == o.spawned_tasks &&
          progress_reports == o.progress_reports &&
          created_resources == o.created_resources
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_href, _created, state, name, started_at, finished_at, non_fatal_errors, error, worker, parent, spawned_tasks, progress_reports, created_resources].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Zest.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
